---
title: ImageCapture
slug: Web/API/ImageCapture
tags:
  - API
  - Experimental
  - Image
  - Image Capture
  - ImageCapture
  - Interface
  - Media
  - MediaStream Image Capture API
  - Reference
---
<div>{{APIRef("MediaStream Image")}}</div>

<p><span class="seoSummary">The <strong><code>ImageCapture</code></strong> interface of the <a href="/en-US/docs/Web/API/MediaStream_Image_Capture_API">MediaStream Image Capture API</a> provides methods to enable the capture of images or photos from a camera or other photographic device. It provides an interface for capturing images from a photographic device referenced through a valid {{domxref("MediaStreamTrack")}}.</span></p>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{domxref("ImageCapture.ImageCapture()", "ImageCapture()")}}</dt>
 <dd>Creates a new <code>ImageCapture</code> object which can be used to capture still frames (photos) from a given {{domxref("MediaStreamTrack")}} which represents a video stream.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref("ImageCapture.track")}} {{readonlyinline}}</dt>
 <dd>Returns a reference to the {{domxref("MediaStreamTrack")}} passed to the constructor.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p>The <code>ImageCapture</code> interface is based on {{domxref("EventTarget")}}, so it includes the methods defined by that interface as well as the ones listed below.</p>

<dl>
 <dt>{{domxref("ImageCapture.takePhoto()")}}</dt>
 <dd>Takes a single exposure using the video capture device sourcing a {{domxref("MediaStreamTrack")}} and returns a {{jsxref("Promise")}} that resolves with a {{domxref("Blob")}} containing the data.</dd>
 <dt>{{domxref("ImageCapture.getPhotoCapabilities()")}}</dt>
 <dd>Returns a {{jsxref("Promise")}} that resolves with a {{domxref("PhotoCapabilities")}} object containing the ranges of available configuration options.</dd>
 <dt>{{domxref("ImageCapture.getPhotoSettings()")}}</dt>
 <dd>Returns a {{jsxref("Promise")}} that resolves with a {{domxref("PhotoSettings")}} object containing the current photo configuration settings.</dd>
 <dt>{{domxref("ImageCapture.grabFrame()")}}</dt>
 <dd>Takes a snapshot of the live video in a {{domxref("MediaStreamTrack")}}, returning an {{domxref("ImageBitmap")}}, if successful.</dd>
</dl>

<h2 id="Example">Example</h2>

<p>The following code is taken from <a href="https://googlechrome.github.io/samples/image-capture/grab-frame-take-photo.html">Chrome's Grab Frame - Take Photo Sample</a>. Since <code>ImageCapture</code> requires some place to capture an image from, the example below starts with a device's media device (in other words a camera).</p>

<p>This example shows, roughly, a {{domxref("MediaStreamTrack")}} extracted from a device's {{domxref("MediaStream")}}. The track is then used to create an <code>ImageCapture</code> object so that <code>takePhoto()</code> and <code>grabFrame()</code> can be called. Finally, it shows how to apply the results of these calls to a canvas object.</p>

<pre class="brush: js">var imageCapture;

function onGetUserMediaButtonClick() {
  navigator.mediaDevices.getUserMedia({video: true})
  .then(mediaStream =&gt; {
    document.querySelector('video').srcObject = mediaStream;

    const track = mediaStream.getVideoTracks()[0];
    imageCapture = new ImageCapture(track);
  })
  .catch(error =&gt; console.log(error));
}

function onGrabFrameButtonClick() {
  imageCapture.grabFrame()
  .then(imageBitmap =&gt; {
    const canvas = document.querySelector('#grabFrameCanvas');
    drawCanvas(canvas, imageBitmap);
  })
  .catch(error =&gt; console.log(error));
}

function onTakePhotoButtonClick() {
  imageCapture.takePhoto()
  .then(blob =&gt; createImageBitmap(blob))
  .then(imageBitmap =&gt; {
    const canvas = document.querySelector('#takePhotoCanvas');
    drawCanvas(canvas, imageBitmap);
  })
  .catch(error =&gt; console.log(error));
}

/* Utils */

function drawCanvas(canvas, img) {
  canvas.width = getComputedStyle(canvas).width.split('px')[0];
  canvas.height = getComputedStyle(canvas).height.split('px')[0];
  let ratio  = Math.min(canvas.width / img.width, canvas.height / img.height);
  let x = (canvas.width - img.width * ratio) / 2;
  let y = (canvas.height - img.height * ratio) / 2;
  canvas.getContext('2d').clearRect(0, 0, canvas.width, canvas.height);
  canvas.getContext('2d').drawImage(img, 0, 0, img.width, img.height,
      x, y, img.width * ratio, img.height * ratio);
}

document.querySelector('video').addEventListener('play', function() {
  document.querySelector('#grabFrameButton').disabled = false;
  document.querySelector('#takePhotoButton').disabled = false;
});</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('MediaStream Image','#imagecaptureapi','ImageCapture')}}</td>
   <td>{{Spec2('MediaStream Image')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.ImageCapture")}}</p>
